package pack;

import java.util.Random;

public class PlayGround {
    private int[][] ground, thiefSituation;
    private int n, m, policeNumbers;
    private boolean catchThief;

    PlayGround(int n, int m, int policeNumbers) {
        this.n = n;
        this.m = m;
        this.policeNumbers = policeNumbers;
        ground = new int[n][m];
        thiefSituation = new int[1][2];
        int i, j;
        for (i = 0; i < n; i++)
            for (j = 0; j < m; j++)
                ground[i][j] = 0;
        catchThief = false;
    }

    public void show(int time) {
        int i, j;

        for (i = 0; i < n; i++) {
            for (j = 0; j < m; j++) {
                if (ground[i][j] == 0)
                    System.out.print("-");
                else if (ground[i][j] == 1) // police
                    System.out.print("X");
                else                        // Dozd
                    System.out.print("*");
            }
            System.out.println();
        }

        try {
            Thread.sleep(time);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public int[][] putRandom() {
        int[][] positions = new int[policeNumbers + 1][2];
        int i = 0, j = 0, k;
        Random rand = new Random();
        if (n * m < policeNumbers) System.out.println("Error!! NOT ENOUGH SPACE FOR POLICES AND THIEF IN GROUND");
        else {
            for (k = 0; k < policeNumbers; k++) {       // police
                i = rand.nextInt(n);
                j = rand.nextInt(m);
                if (ground[i][j] == 0) {
                    ground[i][j] = 1;
                    positions[k][0] = i;   // x
                    positions[k][1] = j;   // y
                } else k--;
            }

            for (k = 0; k < 1; k++) {                   // thief
                i = rand.nextInt(n);
                j = rand.nextInt(m);
                if (ground[i][j] == 0) {
                    ground[i][j] = -1;
                    positions[policeNumbers][0] = i;   // x
                    positions[policeNumbers][1] = j;   // y
                    thiefSituation[0][0] = i;   // x
                    thiefSituation[0][1] = j;   // y
                } else k--;
            }
        }

        return positions;
    }

    public void change(int[][] newPolicesSituation, int xThief, int yThief) {
        int i, j;
        for (i = 0; i < n; i++)
            for (j = 0; j < m; j++)
                ground[i][j] = 0;

        for (i = 0; i < policeNumbers; i++)
            ground[newPolicesSituation[i][0]][newPolicesSituation[i][1]] = 1;

        ground[xThief][yThief] = -1;
    }

    public void changeSituation(int xPrevious, int yPrevious, int xNew, int yNew, int k) {
        if (xNew == thiefSituation[0][0] && yNew == thiefSituation[0][1]) return;
        ground[xPrevious][yPrevious] = 0;
        ground[xNew][yNew] = k;

    }

    public int[][] getGround() {
        return ground;
    }

    public int[][] canPoliceSeeThief() {
        int i, j, I, J;

        if (thiefSituation[0][0] > 1) i = thiefSituation[0][0] - 2;
        else i = 0;
        if (thiefSituation[0][0] < n - 2) I = thiefSituation[0][0] + 3;
        else I = n;

        if (thiefSituation[0][1] > 1) j = thiefSituation[0][1] - 2;
        else j = 0;
        if (thiefSituation[0][1] < m - 2) J = thiefSituation[0][1] + 3;
        else J = m;


        for (int jj; i < I; i++)
            for (jj = j; jj < J; jj++) {
                if (ground[i][jj] == 1)
                    return thiefSituation;

            }

        return null;
    }

    public boolean catchThief() {
        int i, j;
        for (i = 0; i < n; i++)
            for (j = 0; j < m; j++)
                if (ground[i][j] == 100)
                    return true;
        return false;
    }

    public boolean isEmpty(int x, int y) {
        if (ground[x][y] == -1) {
            catchThief = true;
            return true;
        }
        return ground[x][y] == 0;
    }

    public int[][] getNM() {
        int[][] ret = new int[1][2];
        ret[0][0] = n;
        ret[0][1] = m;
        return ret;
    }

    public int[][] getThiefSituation() {
        int[][] ret = new int[1][2];
        ret[0][0] = thiefSituation[0][0];
        ret[0][1] = thiefSituation[0][1];
        return ret;
    }

    public boolean getCatchThief() {
        return catchThief;
    }
    
}
